Subject: Re: MPLS decap with iproute2

From: roopa <[email-masked]>
Date: Mon, 07 Dec 2015 18:37:00 -0800

On 12/7/15, 11:42 AM, Sam Russell wrote:
> Hi,
>
> I've had success with the iproute2 manpage example for encapsulating
> outgoing traffic in MPLS, but I've not found a way to add decap routes
> inbound.
>
> I've tried "ip route -f mpls add 100 dev lo" and other variations, but I
> get netlink errors back.
>
> Has this been built yet? Is there sample config that I can try out? I'm
> running a home-built 4.3 kernel + iproute2 built from head (on ubuntu
> 15.10) and am comfortable with perf and splashing around in the codebase if
> need be.
>
Example below should work
 ip -f mpls route add 100 as 200 via inet 10.1.1.2 dev eth0

You have to enable mpls on the interface first:
echo 1 > /proc/sys/net/mpls/conf/eth0/input

multipath iproute2 patches are not in yet. Will submit them soon.

let me know if you still get errors.